# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::MobileEngagement::Mgmt::V2014_12_01
  module Models
    #
    # Model object.
    #
    #
    class PollQuestionChoice < PollQuestionChoiceLocalization

      include MsRestAzure

      # @return [Integer] Unique identifier of the choice.
      attr_accessor :id

      # @return [Hash{String => PollQuestionChoiceLocalization}] Poll choices
      # can be localized using an optional JSON object. The JSON key is a
      # two-character language code as specified by the ISO 639-1 standard. The
      # corresponding value is an object containing the localizable property
      # title.
      #
      attr_accessor :localization

      # @return [Boolean] A flag indicating if this choice is the default
      # choice for the associated question. Only one choice in the array can
      # have this value set to true. Default value: false .
      attr_accessor :is_default


      #
      # Mapper for PollQuestionChoice class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'PollQuestionChoice',
          type: {
            name: 'Composite',
            class_name: 'PollQuestionChoice',
            model_properties: {
              title: {
                client_side_validation: true,
                required: false,
                serialized_name: 'title',
                constraints: {
                  MaxLength: 256
                },
                type: {
                  name: 'String'
                }
              },
              id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'id',
                type: {
                  name: 'Number'
                }
              },
              localization: {
                client_side_validation: true,
                required: false,
                serialized_name: 'localization',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'PollQuestionChoiceLocalizationElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'PollQuestionChoiceLocalization'
                      }
                  }
                }
              },
              is_default: {
                client_side_validation: true,
                required: false,
                serialized_name: 'isDefault',
                default_value: false,
                type: {
                  name: 'Boolean'
                }
              }
            }
          }
        }
      end
    end
  end
end
